#define _SKB_NUM		200

#define _PLUSB_RXD		0x40
#define _PLUSB_TXOK		0x80

#ifdef __KERNEL__
#define _BULK_DATA_LEN		16384
#define MAX_USB_LEN		16384	/* TODO TODO which length to use? */
#define MAC_OFFSET		10

/*
See /usr/src/linux/include/linux/usb.h for definition of dbg()
*/

/* Product and Vendor IDs */
#define USB_VENDOR_COMPAQ  1183
#define COMPAQ_ITSY_ID     0x505A
#define ID_VENDOR	USB_VENDOR_COMPAQ
#define ID_PRODUCT	COMPAQ_ITSY_ID

typedef struct
{
	struct list_head skb_list;
	struct sk_buff *skb;
	int state;
} skb_list_t,*pskb_list_t;

typedef struct
{
	struct usb_device *usbdev;

	int status;
	int connected;
	int in_bh;
	int opened;

	spinlock_t lock;

	urb_t *inturb;
	urb_t *bulkurb;	

	struct list_head tx_skb_list;
	struct list_head free_skb_list;
	struct tq_struct bh;

	struct sk_buff *skb;			/* added by CF */

	struct net_device net_dev;
	struct net_device_stats net_stats;

	unsigned int writeendp,readendp;	/* added by CF */
	unsigned int pktlen;			/* added by CF */
	unsigned int read_interval;		/* added by CF */
} plusb_t,*pplusb_t;

#endif
